<!DOCTYPE html>
<html>
<head>
  <meta http-equiv="content-type" content="text/html;charset=utf-8">
  <title>readFieldsUniprotList.py</title>
  <link rel="stylesheet" href="pycco.css">
</head>
<body>
<div id='container'>
  <div id="background"></div>
  <div class='section'>
    <div class='docs'><h1>readFieldsUniprotList.py</h1></div>
  </div>
  <div class='clearall'>
  <div class='section' id='section-0'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-0'>#</a>
      </div>
      <p>Fill the database tables with Uniprot values </p>
<p>References:</p>
<p>https://www.uniprot.org/uniprot</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span></span><span class="kn">import</span> <span class="nn">django</span>
<span class="kn">import</span> <span class="nn">os.path</span>
<span class="kn">import</span> <span class="nn">os</span>
<span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="o">.</span><span class="n">setdefault</span><span class="p">(</span><span class="s2">&quot;DJANGO_SETTINGS_MODULE&quot;</span><span class="p">,</span> <span class="s2">&quot;mysiteproyect.settings&quot;</span><span class="p">)</span>
<span class="n">django</span><span class="o">.</span><span class="n">setup</span><span class="p">()</span>
<span class="kn">import</span> <span class="nn">re</span>
<span class="kn">from</span> <span class="nn">requests</span> <span class="kn">import</span> <span class="n">get</span>
<span class="kn">from</span> <span class="nn">proteins.models</span> <span class="kn">import</span> <span class="n">Protein</span><span class="p">,</span> <span class="n">PBD</span>


<span class="n">list_files</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;P31946&#39;</span><span class="p">,</span> <span class="s1">&#39;P62258&#39;</span><span class="p">,</span> <span class="s1">&#39;Q04917&#39;</span><span class="p">,</span> <span class="s1">&#39;P61981&#39;</span><span class="p">,</span> <span class="s1">&#39;P31947&#39;</span><span class="p">,</span>
              <span class="s1">&#39;P27348&#39;</span><span class="p">,</span> <span class="s1">&#39;P63104&#39;</span><span class="p">,</span> <span class="s1">&#39;Q4AC99&#39;</span><span class="p">,</span> <span class="s1">&#39;Q15172&#39;</span><span class="p">,</span> <span class="s1">&#39;Q14738&#39;</span><span class="p">,</span> <span class="s1">&#39;Q16537&#39;</span><span class="p">]</span>

<span class="n">pat</span> <span class="o">=</span> <span class="s1">&#39;./infiles&#39;</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-1'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-1'>#</a>
      </div>
      <p>read file txt</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">def</span> <span class="nf">download</span><span class="p">(</span><span class="n">url</span><span class="p">,</span> <span class="n">file_name</span><span class="p">):</span>
    <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">pat</span><span class="p">,</span> <span class="n">file_name</span><span class="p">),</span> <span class="s2">&quot;wb&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">file</span><span class="p">:</span>
        <span class="n">response</span> <span class="o">=</span> <span class="n">get</span><span class="p">(</span><span class="n">url</span><span class="p">)</span>
        <span class="n">file</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="n">response</span><span class="o">.</span><span class="n">content</span><span class="p">)</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-2'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-2'>#</a>
      </div>
      <p>entry</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre><span class="k">for</span> <span class="n">infile</span> <span class="ow">in</span> <span class="n">list_files</span><span class="p">:</span>
    <span class="n">file_name</span> <span class="o">=</span> <span class="n">infile</span><span class="o">+</span><span class="s1">&#39;.txt&#39;</span>
    <span class="n">url</span> <span class="o">=</span> <span class="s1">&#39;https://www.uniprot.org/uniprot/&#39;</span><span class="o">+</span><span class="n">file_name</span>
    <span class="n">download</span><span class="p">(</span><span class="n">url</span><span class="p">,</span> <span class="n">file_name</span><span class="p">)</span>

    <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">pat</span><span class="p">,</span> <span class="n">file_name</span><span class="p">),</span> <span class="s2">&quot;r&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">txt_file</span><span class="p">:</span>
        <span class="n">f1</span> <span class="o">=</span> <span class="n">txt_file</span><span class="o">.</span><span class="n">readlines</span><span class="p">()</span>

    <span class="n">p</span> <span class="o">=</span> <span class="n">Protein</span><span class="p">()</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-3'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-3'>#</a>
      </div>
      <p>entry_name</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">entry</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
    <span class="n">pattern_entry</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">compile</span><span class="p">(</span><span class="sa">r</span><span class="s1">&#39;AC\s+(\w+)&#39;</span><span class="p">)</span>
    <span class="n">prog_entry</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">compile</span><span class="p">(</span><span class="n">pattern_entry</span><span class="p">)</span>
    <span class="n">result_entry</span> <span class="o">=</span> <span class="n">prog_entry</span><span class="o">.</span><span class="n">match</span><span class="p">(</span><span class="n">f1</span><span class="p">[</span><span class="mi">1</span><span class="p">])</span>
    <span class="n">entry</span> <span class="o">=</span> <span class="n">result_entry</span><span class="o">.</span><span class="n">group</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span>

    <span class="n">p</span><span class="o">.</span><span class="n">entry</span> <span class="o">=</span> <span class="n">entry</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-4'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-4'>#</a>
      </div>
      <p>protein_names</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">entry_name</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
    <span class="n">pattern</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">compile</span><span class="p">(</span><span class="sa">r</span><span class="s1">&#39;ID (.+) Reviewed.+&#39;</span><span class="p">)</span>
    <span class="n">prog</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">compile</span><span class="p">(</span><span class="n">pattern</span><span class="p">)</span>
    <span class="n">result</span> <span class="o">=</span> <span class="n">prog</span><span class="o">.</span><span class="n">match</span><span class="p">(</span><span class="n">f1</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>

    <span class="n">entry_name</span> <span class="o">=</span> <span class="n">result</span><span class="o">.</span><span class="n">group</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span>

    <span class="n">p</span><span class="o">.</span><span class="n">entry_name</span> <span class="o">=</span> <span class="n">entry_name</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-5'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-5'>#</a>
      </div>
      <p>cross_reference_GeneID</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">protein_names_list</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">protein_names</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>

    <span class="n">pattern_protein_names</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">compile</span><span class="p">(</span><span class="sa">r</span><span class="s1">&#39;DE\s+.+Full=(.+);&#39;</span><span class="p">)</span>

    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="n">f1</span><span class="p">)):</span>
        <span class="k">for</span> <span class="n">m</span> <span class="ow">in</span> <span class="n">re</span><span class="o">.</span><span class="n">finditer</span><span class="p">(</span><span class="n">pattern_protein_names</span><span class="p">,</span> <span class="n">f1</span><span class="p">[</span><span class="n">i</span><span class="p">]):</span>
            <span class="k">if</span> <span class="n">m</span><span class="o">.</span><span class="n">group</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">protein_names_list</span><span class="p">:</span>
                <span class="n">protein_names_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">m</span><span class="o">.</span><span class="n">group</span><span class="p">(</span><span class="mi">1</span><span class="p">))</span>

    <span class="n">protein_names</span> <span class="o">=</span> <span class="s2">&quot;. &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">protein_names_list</span><span class="p">)</span>
    <span class="n">p</span><span class="o">.</span><span class="n">protein_names</span> <span class="o">=</span> <span class="n">protein_names</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-6'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-6'>#</a>
      </div>
      <p>gene_names</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">cross_reference_geneID_list</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">cross_reference_geneID</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>

    <span class="n">pattern_geneid</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">compile</span><span class="p">(</span><span class="s1">&#39;DR\s+GeneID;\s(\w+);&#39;</span><span class="p">)</span>

    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="n">f1</span><span class="p">)):</span>
        <span class="k">for</span> <span class="n">m</span> <span class="ow">in</span> <span class="n">re</span><span class="o">.</span><span class="n">finditer</span><span class="p">(</span><span class="n">pattern_geneid</span><span class="p">,</span> <span class="n">f1</span><span class="p">[</span><span class="n">i</span><span class="p">]):</span>
            <span class="k">if</span> <span class="n">m</span><span class="o">.</span><span class="n">group</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">cross_reference_geneID_list</span><span class="p">:</span>
                <span class="n">cross_reference_geneID_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">m</span><span class="o">.</span><span class="n">group</span><span class="p">(</span><span class="mi">1</span><span class="p">))</span>

    <span class="n">cross_reference_geneID</span> <span class="o">=</span> <span class="s2">&quot; &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">cross_reference_geneID_list</span><span class="p">)</span>
    <span class="n">p</span><span class="o">.</span><span class="n">cross_reference_GeneID</span> <span class="o">=</span> <span class="n">cross_reference_geneID</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-7'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-7'>#</a>
      </div>
      <p>organism</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">gen_name_list</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">gen_name</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>

    <span class="n">pattern_gen_name</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">compile</span><span class="p">(</span><span class="s1">&#39;GN\s+Name=(.+);&#39;</span><span class="p">)</span>

    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="n">f1</span><span class="p">)):</span>
        <span class="k">for</span> <span class="n">m</span> <span class="ow">in</span> <span class="n">re</span><span class="o">.</span><span class="n">finditer</span><span class="p">(</span><span class="n">pattern_gen_name</span><span class="p">,</span> <span class="n">f1</span><span class="p">[</span><span class="n">i</span><span class="p">]):</span>
            <span class="k">if</span> <span class="n">m</span><span class="o">.</span><span class="n">group</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">gen_name_list</span><span class="p">:</span>
                <span class="n">gen_name_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">m</span><span class="o">.</span><span class="n">group</span><span class="p">(</span><span class="mi">1</span><span class="p">))</span>

    <span class="n">gen_name</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">gen_name_list</span><span class="p">)</span>

    <span class="n">p</span><span class="o">.</span><span class="n">gene_names</span> <span class="o">=</span> <span class="n">gen_name</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-8'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-8'>#</a>
      </div>
      <p>taxonomy_lineage</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">organism_list</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">organism</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>

    <span class="n">pattern_organism</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">compile</span><span class="p">(</span><span class="s1">&#39;OS\s+(.+).&#39;</span><span class="p">)</span>

    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="n">f1</span><span class="p">)):</span>
        <span class="k">for</span> <span class="n">m</span> <span class="ow">in</span> <span class="n">re</span><span class="o">.</span><span class="n">finditer</span><span class="p">(</span><span class="n">pattern_organism</span><span class="p">,</span> <span class="n">f1</span><span class="p">[</span><span class="n">i</span><span class="p">]):</span>
            <span class="k">if</span> <span class="n">m</span><span class="o">.</span><span class="n">group</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">organism_list</span><span class="p">:</span>
                <span class="n">organism_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">m</span><span class="o">.</span><span class="n">group</span><span class="p">(</span><span class="mi">1</span><span class="p">))</span>

    <span class="n">organism</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">organism_list</span><span class="p">)</span>
    <span class="n">p</span><span class="o">.</span><span class="n">organism</span> <span class="o">=</span> <span class="n">organism</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-9'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-9'>#</a>
      </div>
      <p>sequence</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">taxo_list</span> <span class="o">=</span> <span class="p">[]</span>

    <span class="n">pattern_taxo</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">compile</span><span class="p">(</span><span class="s1">&#39;OC\s+(.+)&#39;</span><span class="p">)</span>

    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="n">f1</span><span class="p">)):</span>
        <span class="k">for</span> <span class="n">m</span> <span class="ow">in</span> <span class="n">re</span><span class="o">.</span><span class="n">finditer</span><span class="p">(</span><span class="n">pattern_taxo</span><span class="p">,</span> <span class="n">f1</span><span class="p">[</span><span class="n">i</span><span class="p">]):</span>
            <span class="k">if</span> <span class="n">m</span><span class="o">.</span><span class="n">group</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">taxo_list</span><span class="p">:</span>
                <span class="n">taxo_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">m</span><span class="o">.</span><span class="n">group</span><span class="p">(</span><span class="mi">1</span><span class="p">))</span>

    <span class="n">taxo1</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">taxo_list</span><span class="p">)</span>
    <span class="n">taxo2</span> <span class="o">=</span> <span class="n">taxo1</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s2">&quot;;&quot;</span><span class="p">)</span>
    <span class="n">taxo3</span> <span class="o">=</span> <span class="s2">&quot; -&gt;&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">taxo2</span><span class="p">)</span>

    <span class="n">p</span><span class="o">.</span><span class="n">taxonomy_lineage</span> <span class="o">=</span> <span class="n">taxo3</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-10'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-10'>#</a>
      </div>
      <p>length</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">seq_list</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="n">pattern_seq</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">compile</span><span class="p">(</span><span class="s1">&#39;SQ\s+SEQUENCE.+;&#39;</span><span class="p">)</span>
    <span class="n">index_inicio</span> <span class="o">=</span> <span class="mi">0</span>

    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="n">f1</span><span class="p">)):</span>
        <span class="k">for</span> <span class="n">m</span> <span class="ow">in</span> <span class="n">re</span><span class="o">.</span><span class="n">finditer</span><span class="p">(</span><span class="n">pattern_seq</span><span class="p">,</span> <span class="n">f1</span><span class="p">[</span><span class="n">i</span><span class="p">]):</span>
            <span class="n">index_inicio</span> <span class="o">=</span> <span class="n">i</span>

    <span class="n">seq_list</span> <span class="o">=</span> <span class="n">f1</span><span class="p">[</span><span class="n">index_inicio</span><span class="o">+</span><span class="mi">1</span><span class="p">:</span><span class="nb">len</span><span class="p">(</span><span class="n">f1</span><span class="p">)</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span>

    <span class="n">seq_list_split_join</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">for</span> <span class="n">l</span> <span class="ow">in</span> <span class="n">seq_list</span><span class="p">:</span>
        <span class="n">seq_list_split_join</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="s2">&quot;&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">l</span><span class="o">.</span><span class="n">split</span><span class="p">()))</span>

    <span class="n">seq</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
    <span class="n">seq</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">seq_list_split_join</span><span class="p">)</span>

    <span class="n">p</span><span class="o">.</span><span class="n">sequence</span> <span class="o">=</span> <span class="n">seq</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-11'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-11'>#</a>
      </div>
      <p>Cross_reference_PDB</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">length</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>
    <span class="n">pattern_length</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">compile</span><span class="p">(</span><span class="sa">r</span><span class="s1">&#39;ID\s.+ (\d+)\s+AA&#39;</span><span class="p">)</span>
    <span class="n">prog_length</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">compile</span><span class="p">(</span><span class="n">pattern_length</span><span class="p">)</span>
    <span class="n">result_length</span> <span class="o">=</span> <span class="n">prog_length</span><span class="o">.</span><span class="n">match</span><span class="p">(</span><span class="n">f1</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
    <span class="n">length</span> <span class="o">=</span> <span class="n">result_length</span><span class="o">.</span><span class="n">group</span><span class="p">(</span><span class="mi">1</span><span class="p">)</span>

    <span class="n">p</span><span class="o">.</span><span class="n">length</span> <span class="o">=</span> <span class="n">length</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-12'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-12'>#</a>
      </div>
      <p>save changes in the protein</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">pattern_function_inicio</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">compile</span><span class="p">(</span><span class="sa">r</span><span class="s1">&#39;CC\s+-!-\s(FUNCTION).+&#39;</span><span class="p">)</span>
    <span class="n">index_inicio_function</span> <span class="o">=</span> <span class="mi">0</span>

    <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="n">f1</span><span class="p">)):</span>
        <span class="k">for</span> <span class="n">m</span> <span class="ow">in</span> <span class="n">re</span><span class="o">.</span><span class="n">finditer</span><span class="p">(</span><span class="n">pattern_function_inicio</span><span class="p">,</span> <span class="n">f1</span><span class="p">[</span><span class="n">i</span><span class="p">]):</span>
            <span class="n">index_inicio_function</span> <span class="o">=</span> <span class="n">i</span>

    <span class="n">function_list</span> <span class="o">=</span> <span class="n">f1</span><span class="p">[</span><span class="n">index_inicio_function</span><span class="o">+</span><span class="mi">1</span><span class="p">:]</span>
    <span class="n">f_idx</span> <span class="o">=</span> <span class="p">[</span><span class="n">i</span> <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">item</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span>
        <span class="n">function_list</span><span class="p">)</span> <span class="k">if</span> <span class="n">re</span><span class="o">.</span><span class="n">search</span><span class="p">(</span><span class="s1">&#39;CC\s+-!-\s+.+:&#39;</span><span class="p">,</span> <span class="n">item</span><span class="p">)]</span>

    <span class="n">f_idx_DR</span> <span class="o">=</span> <span class="p">[</span><span class="n">i</span> <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">item</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span>
        <span class="n">function_list</span><span class="p">)</span> <span class="k">if</span> <span class="n">re</span><span class="o">.</span><span class="n">search</span><span class="p">(</span><span class="sa">r</span><span class="s1">&#39;DR\s+PDB\s*&#39;</span><span class="p">,</span> <span class="n">item</span><span class="p">)]</span>
    <span class="n">f_DR</span> <span class="o">=</span> <span class="p">[</span><span class="n">i</span> <span class="k">for</span> <span class="n">i</span><span class="p">,</span> <span class="n">item</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">function_list</span><span class="p">)</span> <span class="k">if</span> <span class="n">re</span><span class="o">.</span><span class="n">search</span><span class="p">(</span>
        <span class="sa">r</span><span class="s1">&#39;DR\s+PDB\s*;\s*[0-9A-Z]+\s*;\s*.*&#39;</span><span class="p">,</span> <span class="n">item</span><span class="p">)]</span>
    <span class="n">cross_reference_PDB</span> <span class="o">=</span> <span class="s2">&quot;&quot;</span>

    <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">f_DR</span><span class="p">)</span> <span class="o">!=</span> <span class="mi">0</span><span class="p">:</span>

        <span class="k">if</span> <span class="n">f_idx_DR</span><span class="o">.</span><span class="n">index</span><span class="p">(</span><span class="n">f_DR</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">])</span> <span class="o">&lt;</span> <span class="nb">len</span><span class="p">(</span><span class="n">f_idx_DR</span><span class="p">)</span><span class="o">-</span><span class="mi">1</span><span class="p">:</span>
            <span class="n">index_fin_pdb</span> <span class="o">=</span> <span class="n">f_idx_DR</span><span class="p">[</span><span class="n">f_idx_DR</span><span class="o">.</span><span class="n">index</span><span class="p">(</span><span class="n">f_DR</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">])</span><span class="o">+</span><span class="mi">1</span><span class="p">]</span>
            <span class="n">act_list_join</span> <span class="o">=</span> <span class="s2">&quot; &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">function_list</span><span class="p">[</span><span class="n">f_DR</span><span class="p">[</span><span class="mi">0</span><span class="p">]:</span><span class="n">index_fin_pdb</span><span class="p">])</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">act_list_join</span> <span class="o">=</span> <span class="s2">&quot; &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">function_list</span><span class="p">[</span><span class="n">f_DR</span><span class="p">[</span><span class="mi">0</span><span class="p">]])</span>

        <span class="n">rep1</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">sub</span><span class="p">(</span><span class="s1">&#39;DR\s+&#39;</span><span class="p">,</span> <span class="s1">&#39; &#39;</span><span class="p">,</span> <span class="n">act_list_join</span><span class="p">)</span>
        <span class="n">rep2</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">sub</span><span class="p">(</span><span class="s1">&#39;</span><span class="se">\n</span><span class="s1">&#39;</span><span class="p">,</span> <span class="s1">&#39; &#39;</span><span class="p">,</span> <span class="n">rep1</span><span class="p">)</span>
        <span class="n">rep3</span> <span class="o">=</span> <span class="n">rep2</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span>
        <span class="n">cross_reference_PDB</span> <span class="o">=</span> <span class="n">rep3</span>
        <span class="n">p</span><span class="o">.</span><span class="n">cross_reference_PDB</span> <span class="o">=</span> <span class="n">cross_reference_PDB</span>

    <span class="k">else</span><span class="p">:</span>

        <span class="n">p</span><span class="o">.</span><span class="n">cross_reference_PDB</span> <span class="o">=</span> <span class="n">cross_reference_PDB</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-13'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-13'>#</a>
      </div>
      <p>fill model PBD</p>
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">p</span><span class="o">.</span><span class="n">save</span><span class="p">()</span></pre></div>
    </div>
  </div>
  <div class='clearall'></div>
  <div class='section' id='section-14'>
    <div class='docs'>
      <div class='octowrap'>
        <a class='octothorpe' href='#section-14'>#</a>
      </div>
      
    </div>
    <div class='code'>
      <div class="highlight"><pre>    <span class="n">lcross</span> <span class="o">=</span> <span class="n">cross_reference_PDB</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s1">&#39;PDB;&#39;</span><span class="p">)</span>
    <span class="n">en</span> <span class="o">=</span> <span class="n">entry</span>

    <span class="k">for</span> <span class="n">pbd</span> <span class="ow">in</span> <span class="n">lcross</span><span class="p">:</span>
        <span class="k">if</span> <span class="p">(</span><span class="n">pbd</span> <span class="o">!=</span> <span class="s2">&quot;&quot;</span><span class="p">):</span>
            <span class="n">id_pbd</span> <span class="o">=</span> <span class="n">pbd</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s2">&quot;;&quot;</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span>
            <span class="n">desc</span> <span class="o">=</span> <span class="s2">&quot;;&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">pbd</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s2">&quot;;&quot;</span><span class="p">)[</span><span class="mi">1</span><span class="p">:])</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span>
            <span class="n">PBD</span><span class="o">.</span><span class="n">objects</span><span class="o">.</span><span class="n">create</span><span class="p">(</span><span class="n">id_pbd</span><span class="o">=</span><span class="n">id_pbd</span><span class="p">,</span> <span class="n">entry</span><span class="o">=</span><span class="n">en</span><span class="p">,</span>
                               <span class="n">protein</span><span class="o">=</span><span class="n">p</span><span class="p">,</span> <span class="n">description</span><span class="o">=</span><span class="n">desc</span><span class="p">)</span>

</pre></div>
    </div>
  </div>
  <div class='clearall'></div>
</div>
</body>
